using System;
using System.Collections;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Messaging;
using Kodama.Aop.Interceptor;

namespace Kodama.Aop.JoinPoint
{
    /// <summary>
    /// MethodInvocation
    /// </summary>
    /// <seealso cref="Kodama.Aop.Weaver.AspectWeaver"/>
    /// <seealso href="http://aopalliance.sourceforge.net/doc/index.html">AOP Alliance</seealso>
    public class MethodInvocation : IInvocation
    {
        /// <summary>
        /// \bhĂяoIuWFNg
        /// </summary>
        private object target;

        /// <summary>
        /// \bhĂяobZ[W
        /// </summary>
        private IMethodCallMessage message;

        /// <summary>
        /// ɌĂяoׂIMessageSink
        /// </summary>
        private IMessageSink nextSink;

        /// <summary>
        /// \bhɌѕtꂽInterceptor
        /// </summary>
        private IMethodInterceptor[] interceptors;

        /// <summary>
        /// Interceptor̍ċAĂяox
        /// </summary>
        private int interceptIndex;

        /// <summary>
        /// \bhĂяoIuWFNg
        /// </summary>
        public object Target
        {
            get { return target; }
        }

        /// <summary>
        /// Ăяö
        /// </summary>
        public object[] Arguments
        {
            get { return message.Args; }
        }

        /// <summary>
        /// \bhĂяobZ[W
        /// </summary>
        public IMethodCallMessage Message
        {
            get { return message; }
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="obj">\bhĂяoIuWFNg</param>
        /// <param name="msg">\bhĂяobZ[W</param>
        /// <param name="sink">ɌĂяoׂIMessageSink</param>
        /// <param name="invokeInterceptors">MethodInvocationŌĂяoInterceptor</param>
        internal MethodInvocation(
            object               obj,
            IMethodCallMessage   msg,
            IMessageSink         sink,
            IMethodInterceptor[] invokeInterceptors)
		{
            target         = obj;
            message        = msg;
            nextSink       = sink;
            interceptors   = invokeInterceptors;
            interceptIndex = 0;
        }

        /// <summary>
        /// ŏInterceptor̃`F[̌Ăяos܂
        /// </summary>
        /// <param name="outArgumemnts">\bhout</param>
        /// <returns>\bh̖߂l</returns>
        /// <remarks>
        /// Interceptorݒ肳ĂꍇAInterceptor̐
        /// MethodInvocation#ProceedInterceptor#InvokeċAI
        /// JԂĂяoB̃\bh͂̍ŏ̌Ăяo
        /// ȂB{IɃbZ[WVN炵Ă΂ȂB
        /// </remarks>
        public object FirstProceed(out object[] outArgumemnts)
        {
            interceptIndex = 0;
            return Proceed(out outArgumemnts);
        }

        /// <summary>
        /// Interceptor̃`F[̌Ăяos܂
        /// </summary>
        /// <param name="outArgumemnts">\bhout</param>
        /// <returns>\bh̖߂l</returns>
        public object Proceed(out object[] outArgumemnts)
        {
            while (interceptIndex < interceptors.Length)
            {
                return interceptors[interceptIndex++].Invoke(this, out outArgumemnts);
            }

            IMethodReturnMessage ret = (IMethodReturnMessage)nextSink.SyncProcessMessage(message);

            outArgumemnts = ret.OutArgs;

            if (ret.Exception != null)
            {
                throw ret.Exception;
            }

            return ret.ReturnValue;
        }

        /// <summary>
        /// Ăяoɓ̑ѕtĂ邩ǂ`FbN
        /// </summary>
        /// <param name="attrType">т`FbN鑮̌^</param>
        /// <returns>ѕtĂ邩ǂ</returns>
        public bool IsDefined(Type attrType)
        {
           return Attribute.IsDefined(message.MethodBase, attrType);
        }
    }
}
