using System;
using System.Reflection;
using System.Text.RegularExpressions;
using Kodama.Aop.Pointcut.Compose;

namespace Kodama.Aop.Pointcut.Compose.Method
{
    /// <summary>
    /// K\ƃ\bh̖OŃtB^OPointcut
    /// </summary>
    /// <seealso cref="Kodama.Aop.Weaver.AspectWeaver"/>
    /// <seealso href="http://aopalliance.sourceforge.net/doc/index.html">AOP Alliance</seealso>
    public class MethodNamePointcut : ComposiblePointcut
    {
        /// <summary>
        /// tB^O郁\bh̐K\
        /// </summary>
        private Regex regex;

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="name">tB^O郁\bh̐K\</param>
        public MethodNamePointcut(string name)
        {
            regex = new Regex(name);
        }

        /// <summary>
        /// w肳ꂽ\bhAXyNg̑ΏۂƂȂ邩`FbN܂
        /// </summary>
        /// <param name="method">`FbN郁\bh</param>
        /// <returns>w肳ꂽ\bhAXyNg̑ΏۂƂȂ邩ǂ</returns>
        public override bool IsApplied(MethodBase method)
        {
            Match m = regex.Match(method.Name);
            return m.Success && (string.Compare(method.Name, m.Value) == 0);
        }
    }
}
