using System;
using System.Collections;
using System.IO;
using System.Reflection;
using Microsoft.Vsa;
using Kodama.Script.Engine;
using Kodama.Script.Engine.Vsa;

namespace Kodama.Script.Engine.Vsa.JScript
{
	/// <summary>
	/// JScriptGWł
	/// </summary>
    /// <remarks>
    /// ̃NXVisual Studio for Application𗘗pĂ܂B
    /// .NET Framework2.0łObsoleteɂȂ̂ŁAɗCodeDom
    /// p̂𗘗pĂB
    /// </remarks>
    public class JScriptEngine : IScriptEngine
    {
        /// <summary>
        /// IVsaSitepNXBIɎgp
        /// </summary>
        private class JScriptVsaSite : IVsaSite
        {
            /// <summary>
            /// ftHg[gjJ
            /// </summary>
            private const string DEFAULT_ROOT_MONIKER = "Kodama://Script/";

            /// <summary>
            /// ftHgO
            /// </summary>
            private const string DEFAULT_ROOT_NAME_SPACE = "Kodama.Script";

            /// <summary>
            /// VsaGW
            /// </summary>
            private IVsaEngine vsaEngine = new Microsoft.JScript.Vsa.VsaEngine();

            /// <summary>
            /// RpCG[
            /// </summary>
            private ArrayList errors = new ArrayList();

            /// <summary>
            /// XNvgQƂłO[oIuWFNg
            /// </summary>
            private Hashtable globalObjectMap = new Hashtable();

            /// <summary>
            /// XNvg̃AZu
            /// </summary>
            /// <remarks>
            /// ăXNvg̃^擾ł
            /// </remarks>
            public Assembly ScriptAssembly 
            {
                get { return vsaEngine.Assembly; }
            }

            /// <summary>
            /// fobO𐶐邩ǂ
            /// </summary>
            public bool GenerateDebugInfo
            {
                get { return vsaEngine.GenerateDebugInfo; }
                set { vsaEngine.GenerateDebugInfo = value; }
            }

            /// <summary>
            /// RXgN^
            /// </summary>
            public JScriptVsaSite()
            {
                // ȑOɃRpCXNvgR[hS~ƂĎc邱Ƃ
                // (IVsaEnginẽoO?)̂Ń[gjJ͖񃆃j[NȖOƂ
                vsaEngine.RootMoniker = DEFAULT_ROOT_MONIKER + Guid.NewGuid().ToString() + "/";;
                vsaEngine.Site        = this;
                vsaEngine.InitNew();
                vsaEngine.RootNamespace     = DEFAULT_ROOT_NAME_SPACE;
                vsaEngine.GenerateDebugInfo = true;
            }

            /// <summary>
            /// XNvgŎQƂAZuǉ
            /// </summary>
            /// <remarks>
            /// AZu̎QƂ̓RpCOɒǉĂB
            /// </remarks>
            /// <param name="assemblyName">XNvgŎQƂAZu</param>
            public void AddReference(string assemblyName)
            {
                IVsaReferenceItem refItem = (IVsaReferenceItem)vsaEngine.Items.CreateItem
                    (assemblyName, VsaItemType.Reference, VsaItemFlag.None);
                refItem.AssemblyName = assemblyName;
            }

            /// <summary>
            /// XNvg݂O[oȃCX^Xǉ
            /// </summary>
            /// <remarks>
            /// O[oȃCX^X̓RpCOɒǉĂB
            /// </remarks>
            /// <param name="name">XNvgQƂƂɂCX^X</param>
            /// <param name="globalObject">XNvgɒǉO[oȃCX^X</param>
            public void AddGlobalObject(string name, object globalObject)
            {
                IVsaGlobalItem  globalItem = (IVsaGlobalItem)vsaEngine.Items.CreateItem
                    (name, VsaItemType.AppGlobal, VsaItemFlag.None);
                globalItem.TypeString = globalObject.GetType().FullName;
                globalObjectMap.Add(name, globalObject);
            }

            /// <summary>
            /// XNvgR[hǉ
            /// </summary>
            /// <param name="name">XNvgR[h</param>
            /// <param name="code">ǉXNvgR[h</param>
            public void AddScriptCode(string name, string code)
            {
                IVsaCodeItem codeItem = (IVsaCodeItem)vsaEngine.Items.CreateItem
                    (name,  VsaItemType.Code, VsaItemFlag.None);
                codeItem.SourceText = code;
            }

            /// <summary>
            /// XNvgRpC
            /// </summary>
            /// <exception cref="VsaCompileErrorException">
            /// RpCG[ꍇ̗͂O𓊂
            /// </exception>
            public void Compile()
            {
                errors.Clear();
                if (!vsaEngine.Compile())
                {
//                    IVsaError[] cei = (IVsaError[])errors.ToArray(typeof(IVsaError));   // ̂OƂ
                    int size = 0;
                    for (int i = 0; i < errors.Count; ++i)
                    {
                        // 肦Ȃ͂ǁÂG[̂ŔÔ
                        if (errors[i] is IVsaError)
                        {
                            ++size;
                        }
                    }
                    IVsaError[] cei = new IVsaError[size];
                    for (int i = 0, j = 0; i < cei.Length; ++i, ++j)
                    {
                        // 肦Ȃ͂ǁÂG[̂ŔÔ
                        if (errors[i] is IVsaError)
                        {
                            cei[j] = (IVsaError)errors[i];
                        }
                    }
                    throw new VsaCompileErrorException(cei);
                }
            }

            /// <summary>
            /// XNvgs
            /// </summary>
            /// <exception cref="NotCompiledException">
            /// XNvgRpCĂȂꍇ̗͂O𓊂
            /// </exception>
            /// <exception cref="ScriptEntryPointNotFoundException">
            /// Gg[|Cg݂Ȃꍇ̗͂O𓊂
            /// </exception>
            public void Run()
            {
                if (!vsaEngine.IsCompiled)
                {
                    throw new NotCompiledException();
                }
                vsaEngine.Run();
            }

            /// <summary>
            /// XNvg̎s~
            /// </summary>
            public void Stop()
            {
                vsaEngine.Reset();
            }

            /// <summary>
            /// XNvg̃\[XJAXNvgGW𖳌ɂ
            /// </summary>
            /// <remarks>
            /// IXNvgGW͂̃\bhĂяoĂB
            /// </remarks>
            public void Close()
            {
                if (vsaEngine.IsRunning)
                {
                    Stop();
                }
                vsaEngine.RevokeCache();
                vsaEngine.Close();
                globalObjectMap.Clear();
                errors.Clear();
            }

            /// <summary>
            /// ???
            /// </summary>
            /// <param name="itemName">???</param>
            /// <param name="eventSourceName">???</param>
            /// <returns>???</returns>
            object IVsaSite.GetEventSourceInstance(string itemName, string eventSourceName)
            {
                if (globalObjectMap.Contains(eventSourceName))
                {
                    return globalObjectMap[eventSourceName];
                }
                return null;
            }

            /// <summary>
            /// XNvg猩O[oIuWFNg擾
            /// </summary>
            /// <param name="name">O[oIuWFNg̖O</param>
            /// <returns>O[oIuWFNg</returns>
            object IVsaSite.GetGlobalInstance(string name)
            {
                if (globalObjectMap.Contains(name))
                {
                    return globalObjectMap[name];
                }
                return null;
            }

            /// <summary>
            /// ???
            /// </summary>
            /// <param name="notify">???</param>
            /// <param name="info">???</param>
            void IVsaSite.Notify(string notify, object info)
            {
            }

            /// <summary>
            /// ???
            /// </summary>
            /// <param name="pe">???</param>
            /// <param name="debugInfo">???</param>
            void IVsaSite.GetCompiledState(out Byte[] pe, out Byte[] debugInfo)
            {
                pe = debugInfo = null;
            }

            /// <summary>
            /// RpCG[ɌĂ΂郁\bh
            /// </summary>
            /// <param name="err">RpCG[</param>
            /// <returns>RpCG[pĕ񍐂邩ǂ</returns>
            bool IVsaSite.OnCompilerError(IVsaError err)
            {
                errors.Add(err);
                return true;
            }
        }

        /// <summary>
        /// IVsaSiteGW
        /// </summary>
        JScriptVsaSite site = new JScriptVsaSite();

        /// <summary>
        /// XNvg̃AZu
        /// </summary>
        /// <remarks>
        /// ăXNvg̃^擾łB
        /// </remarks>
        public Assembly ScriptAssembly
        {
            get { return site.ScriptAssembly; }
        }

        /// <summary>
        /// fobO𐶐邩ǂ
        /// </summary>
        public bool GenerateDebugInfo
        {
            get { return site.GenerateDebugInfo; }
            set { site.GenerateDebugInfo = value; }
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        public JScriptEngine()
        {
            site.AddReference("system.dll");
            site.AddReference("mscorlib.dll");
            site.AddReference(Assembly.GetExecutingAssembly().Location);
        }

        /// <summary>
        /// XNvgŎQƂAZuǉ
        /// </summary>
        /// <remarks>
        /// AZu̎QƂ̓RpCOɒǉĂB
        /// </remarks>
        /// <param name="assemblyName">XNvgŎQƂAZu</param>
        public void AddReference(string assemblyName)
        {
            site.AddReference(assemblyName);
        }

        /// <summary>
        /// XNvg݂O[oȃCX^Xǉ
        /// </summary>
        /// <remarks>
        /// O[oȃCX^X̓RpCOɒǉĂB
        /// </remarks>
        /// <param name="name">XNvgQƂƂɂCX^X</param>
        /// <param name="obj">XNvgɒǉO[oȃCX^X</param>
        public void AddGlobalIntstance(string name, object obj)
        {
            site.AddGlobalObject(name, obj);
        }

        /// <summary>
        /// XNvgt@CǂݏoAɂR[hɒǉ
        /// </summary>
        /// <param name="filename">XNvgt@C</param>
        public void AddScriptCodeFromFile(string filename)
        {
            StreamReader reader = new StreamReader(filename);
            string code = reader.ReadToEnd();
            reader.Close();
            site.AddScriptCode(Path.GetFileNameWithoutExtension(filename), code);
        }

        /// <summary>
        /// eLXgɂR[hɒǉ
        /// </summary>
        /// <param name="name">XNvg</param>
        /// <param name="code">ǉeLXg</param>
        public void AddScriptCodeFromText(string name, string code)
        {
            site.AddScriptCode(name, code);
        }

        /// <summary>
        /// XNvgRpC
        /// </summary>
        /// <exception cref="VsaCompileErrorException">
        /// RpCG[ꍇ̗͂O𓊂
        /// </exception>
        public void Compile()
        {
            site.Compile();
        }

        /// <summary>
        /// XNvgs
        /// </summary>
        /// <exception cref="NotCompiledException">
        /// XNvgRpCĂȂꍇ̗͂O𓊂
        /// </exception>
        public void Run()
        {
            site.Run();
        }

        /// <summary>
        /// XNvg̎s~
        /// </summary>
        public void Stop()
        {
            site.Stop();
        }

        /// <summary>
        /// XNvg̃\[XJAXNvgGW𖳌ɂ
        /// </summary>
        /// <remarks>
        /// IXNvgGW͂̃\bhĂяoĂB
        /// </remarks>
        public void Close()
        {
            site.Close();
        }
    }
}
